/*
 VBI caputer sample probram.
 1999-02-09 Hiroki Mori
 */

#include <sys/fcntl.h>
#include <stdio.h>
#include <machine/ioctl_meteor.h>
#include <machine/ioctl_bt848.h>
#include <signal.h>
#include <setjmp.h>

#define ROWS 240
#define COLS 320

typedef unsigned char uint8;
typedef signed char int8;

extern int errno;

int bt848;
int tuner;
int vbi;

int dumpfd;

sig_t done() {
	int c;
	c = METEOR_CAP_STOP_CONT;
	ioctl(vbi, METEORCAPTUR, &c);

	close(dumpfd);

	close(vbi);
	close(tuner);
	close(bt848);

        exit(0);
}

main(int ac, char **av)
{
	struct meteor_geomet geo;
	int c, count;
	int row, col, i, size;
	unsigned char *buff;

	count = 100;
	if(ac == 2)
		count = atoi(av[1]);
	if ((bt848 = open("/dev/bktr0", O_RDONLY)) < 0) {
		printf("open failed: %d\n", errno);
		exit(1);
	}
	if ((tuner = open("/dev/tuner0", O_RDONLY)) < 0) {
		printf("open failed: %d\n", errno);
		exit(1);
	}
	if ((vbi = open("/dev/vbi0", O_RDONLY)) < 0) {
		printf("open failed: %d\n", errno);
		exit(1);
	}

	dumpfd = open("dumpfile", O_CREAT | O_RDWR, 0644);
	
	buff = (unsigned char *)malloc(1024 * 128);

	/* set up the capture type and size */

        i = 112;
        if (ioctl(bt848, METEORSCONT, &i) < 0) {
                fprintf(stderr, "ioctl failed: %s\n", strerror(errno));
		exit(0);

        }

        i = 0x70;
        if (ioctl(bt848, METEORSBRIG, &i) < 0) {
                fprintf(stderr, "ioctl failed: %s\n", strerror(errno));
		exit(0);

        }

	i = CHNLSET_JPNBCST;
        if (ioctl(tuner, TVTUNER_SETTYPE, &i) < 0) {
                fprintf(stderr, "ioctl failed: %s\n", strerror(errno));
		exit(0);

        }

	i = 6;
        if (ioctl(tuner, TVTUNER_SETCHNL, &i) < 0) {
                fprintf(stderr, "ioctl failed: %s\n", strerror(errno));
		exit(0);

        }

        geo.rows = ROWS;
        geo.columns = COLS;
	geo.frames = 1;
	geo.oformat = METEOR_GEO_RGB24 | METEOR_GEO_EVEN_ONLY; 
        if (ioctl(bt848, METEORSETGEO, &geo) < 0) {
		printf("ioctl failed: %d\n", errno);
		exit(1);
	}

	c = METEOR_INPUT_DEV1;
	if (ioctl(bt848, METEORSINPUT, &c) < 0) {
		printf("ioctl failed: %d\n", errno);
		exit(1);
	}

	signal(SIGINT,  (sig_t) done);
	c = 1;
	ioctl(bt848, BT848SCBUF, &c);

	c = METEOR_CAP_CONTINOUS;
	ioctl(vbi, METEORCAPTUR, &c);
	while(count--) {
		size = read(vbi, buff, 1024 * 128);
		write(dumpfd, buff, size);
		usleep(100000);
	}

	close(dumpfd);

	close(vbi);
	close(tuner);
	close(bt848);

	exit(0);
}
